using JiShe.CollectBus.Common.Consts;
using JiShe.CollectBus.Common.Enums;
using JiShe.CollectBus.Common.Extensions;
using JiShe.CollectBus.IotSystems.Ammeters;
using JiShe.CollectBus.IotSystems.Devices;
using JiShe.CollectBus.Protocol.Contracts.Protocol.Dto;
using JiShe.CollectBus.Protocol.Dto;
using JiShe.CollectBus.Protocol.Interfaces;
using JiShe.CollectBus.Protocol3761;
using Microsoft.Extensions.Logging;

namespace JiShe.CollectBus.Protocol.T37612012.AnalysisData.AFN_00H
{
    /// <summary>
    /// 5.1.3.2 F2：全部否认
    /// </summary>
    public class AFN0_F2_Analysis : IAnalysisStrategy<TB3761>
    {
        private readonly ILogger<AFN0_F2_Analysis> _logger;
        private readonly DataStorage _dataStorage;
        public AFN0_F2_Analysis(ILogger<AFN0_F2_Analysis> logger, DataStorage dataStorage)
        {
            _logger = logger;
            _dataStorage = dataStorage;
        }
        public async Task<bool> ExecuteAsync(TB3761 input, Action<dynamic>? result = null)
        {
            try
            {
                ArgumentNullException.ThrowIfNull(input);
                ArgumentNullException.ThrowIfNull(input.A.Code);
                var data = new AnalysisBaseDto<bool?>()
                {
                    FiledDesc = "全部否认",
                    DataValue = false,
                    ItemType = $"{input.AFN_FC.AFN.HexToDecStr().PadLeft(2, '0')}_{input.DT.Fn}"
                };
                // 查询电表信息
                DeviceInfo? deviceInfo = await _dataStorage.GetDeviceInfoAsync(input.A.Code);
                if (deviceInfo != null)
                {
                    data.ProjectId = deviceInfo.ProjectID;
                    data.DeviceId = deviceInfo.FocusId;
                    data.DatabaseBusiID = deviceInfo.DatabaseBusiID;
                    data.DeviceAddress = deviceInfo.FocusAddress;
                    data.DeviceType = MeterTypeEnum.Focus;
                    data.FocusId = deviceInfo.FocusId;
                }
                UnitDataAnalysis<AnalysisBaseDto<bool?>> dto = new UnitDataAnalysis<AnalysisBaseDto<bool?>>
                {
                    Code = input.A.Code,
                    AFN = input.AFN_FC.AFN,
                    Fn = input.DT.Fn,
                    Pn = input.DA.Pn,
                    Data = data,
                    ReceivedHexMessage = input.BaseHexMessage.HexMessageString,
                    MessageId = input.MessageId,
                    ReceivedTime =input.ReceivedTime,
                    DensityUnit = DensityUnit.None,
                    TimeDensity = -1,
                    DataType = IOTDBDataTypeConst.Log
                };
                result?.Invoke(dto);
#if DEBUG
                _logger.LogWarning($"全部否认:{input.A.Code}-{input.DT.Fn}-{input.BaseHexMessage.HexMessageString}");
#endif
                await _dataStorage.SaveDataToIotDbAsync<bool?>(dto);
                return await Task.FromResult(true);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, $"00_2解析失败:{input.A.Code}-{input.DT.Fn}-{input.BaseHexMessage.HexMessageString},{ex.Message}");
            }
            return await Task.FromResult(false);
        }

       
    }
}
